com.corticon.eclipse.studio.rule.rulesheet.core

## Interface IRulesheetModelAPI

- All Superinterfaces:
    IModelAPI, com.corticon.rulebuilder.IScopeUtilities
  All Known Subinterfaces:
    IRulesheetTableModelAPI

      public interface IRulesheetModelAPI
      extends IModelAPI, com.corticon.rulebuilder.IScopeUtilities

  The Rulesheet Model API provides a standardized interface for querying and manipulating Rulesheet model objects.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.Action` | `addAction(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule, int aiIndex)` Add a new Action instance to the specified PRule.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.Condition` | `addCondition(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule, int aiIndex)` Add a new Condition instance to the specified PRule.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.Filter` | `addFilter(int aiIndex)` Add a new Filter instance to the PRuleset.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable` | `addLogicalVariable(org.eclipse.emf.ecore.EClass aEClass, int aiIndex)` Deprecated. Clean up of ModelAPI of EMF parametere objects. Replacing them with Corticon interfaces to conceal EMF behind top layer of our API. This will enable us to change out EMF if ever needed.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable` | `addLogicalVariable(IEntity aIEntity, int aiIndex)` Add a new LogicalVariable instance to the PRuleset.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable` | `addLogicalVariable(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable, org.eclipse.emf.ecore.EReference aEReference, int aiIndex)` Deprecated. Clean up of ModelAPI of EMF parametere objects. Replacing them with Corticon interfaces to conceal EMF behind top layer of our API. This will enable us to change out EMF if ever needed.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable` | `addLogicalVariable(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable, IAssociationEnd aIAssociationEnd, int aiIndex)` Add a new LogicalVariable instance to the PRuleset.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.ReferencedAttribute` | `addReferencedAttribute(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable, IAttribute aIAttribute, int aiIndex)` Add a new ReferencedAttribute instance to the specified LogicalVariable.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule` | `addRule(int aiIndex)` Add a new PRule to the rule set.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement` | `addRuleStatement(int aiIndex)` Add a new RuleStatement instance to the PRuleset.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.Action` | `createAction()` Create and return a new independent Action instance.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.Condition` | `createCondition()` Create and return a new independent Condition instance.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.Filter` | `createFilter()` Create and return a new independent Filter instance.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule` | `createRule()` Create and return a new independent PRule instance.
    `com.corticon.rulesemf.assetmodel.RulesheetAsset` | `createRulesheet(org.eclipse.emf.common.util.URI aURIRulesheet)` Create a new Rulesheet resource with the specified URI.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement` | `createRuleStatement()` Create and return a new independent RuleStatement instance.
    `void` | `deleteRulesheet()` Delete the Rulesheet and remove its respective Resource.
    `IEntity` | `findEntity(java.lang.String astrEntityName)` Given an entity name appearing in the Scope section, return the corresponding IEntity by traversing from Scope to the Vocabulary.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable` | `findLogicalVariable(java.lang.String astrAlias)` Find the logical variable corresponding to a specified alias.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable` | `findLogicalVariableImplicit(java.lang.String astrInput)` Find the logical variable corresponding to a specified alias, implicit variable or combination.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRuleset` | `findRuleset()` Finder for PRuleset.
    `com.corticon.rulesemf.assetmodel.RulesheetAsset` | `findRulesheetAsset()` Finder for RulesheetAsset.
    `com.corticon.rulebuilder.IAliasUtilities` | `getAliasUtilities()` Return an instance of alias utilities service.
    `java.util.List` | `getAllLogicalVariables(java.util.List aListLogicalVariables, java.util.List aList)` Return a list of all Logical Variables.
    `java.lang.String` | `getConvertedAliasName(java.lang.String astrAliasName)` This method will take in the astrAliasName and verify that it conforms to Corticon's naming standards.
    `java.lang.String` | `getLogicalVariablePath(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable, boolean abBase)` Given a LogicalVariable instance, traverse upwards formatting in order to construct a base or localized string representation of the alias starting with the root entity or alias name.
    `java.lang.String` | `getNewRulesheetName(org.eclipse.emf.common.util.URI aURIContainer)` Given the URI of a container in the storage system, create a new unique Rulesheet name using sequence numbers if necessary.
    `java.lang.String` | `getNextAvailableAliasName(java.lang.String astrAliasName)` This method will take in the astrAliasName that is passed in and verify that it is unique in the Rulesheet.
    `java.lang.String` | `getNextAvailableConvertedAliasName(java.lang.String astrAliasName)` This method will take in the astrAliasName and call into getConvertedAliasName(String) and getNextAvailableAliasName(String) to return a recommended alias name.
    `IOperationsModelAPI` | `getOperationsModelAPI()` Return an instance of the Operations model API with its state set identically to *this* API.
    `com.corticon.rulebuilder.IParser` | `getParser()` Return an instance of the parsing service.
    `com.corticon.rulebuilder.IRulebuilderFactory` | `getRulebuilderFactory()` Return an instance of IRulebuilder factory.
    `com.corticon.rulebuilder.ISemanticAnalysis` | `getSemanticAnalysis()` Return an instance of the semantic analysis service.
    `int` | `getTotalNumberOfRules()` Returns the total number of Rules for the Rulesheet
    `IDomain` | `getVocabulary()` Get vocabulary
    `IVocabularyModelAPI` | `getVocabularyModelAPI()` Return an instance of the Vocabulary model API with its state set identically to *this* API.
    `org.eclipse.emf.common.util.URI` | `getVocabularyURI()` Return the URI of the Vocabulary, even if that Vocabulary is missing.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.Action` | `insertAction(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule, int aiIndex)` Insert a new Action instance into the specified PRule.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.Condition` | `insertCondition(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule, int aiIndex)` Insert a new Condition instance into the specified PRule.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule` | `insertRule(int aiIndex)` Insert a new PRule instance into the PRuleset.
    `boolean` | `isDatabaseAccessEnabled()` Method to return an indication of whether database access support is enabled.
    `boolean` | `isDatabaseEnabled(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable)` Method to determine whether a given LogicalVariable should be considered database enabled.
    `boolean` | `isDeployable()` Return an indication of whether this asset is deployable (i.e., whether the asset has any un-demoted errors).
    `boolean` | `isFilterDatabaseReady(com.corticon.rulesemf.canonicalrulemodel.rulesheet.Filter aFilter)` Determine if the input filter is a possible database query
    `boolean` | `isProcessAllLogicalLoops()` Returns true, if the OperationMode is set to EngineOperationMode.PROCESS_ALL_LOGICAL_LOOPS
    `boolean` | `isProcessMultiRuleLogicalLoops()` Returns true, if the OperationMode is set to EngineOperationMode.PROCESS_MULTI_RULE_LOGICAL_LOOPS
    `boolean` | `isVocabularyAvailable()` Determine whether the Vocabulary for this Rulesheet is available.
    `com.corticon.rulesemf.expression.OpaqueExpression` | `makeOpaqueExpression(java.lang.String astrValue)` Factory method to create an OpaqueExpression from a string.
    `com.corticon.rulesemf.canonicalrulemodel.rulesheet.RulesheetString` | `makeRulesheetString(java.lang.String astrValue)` Factory method to create a RulesheetString from a string.
    `boolean` | `removeAction(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule, com.corticon.rulesemf.canonicalrulemodel.rulesheet.Action aAction)` Remove an Action from the specified PRule.
    `boolean` | `removeCondition(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule, com.corticon.rulesemf.canonicalrulemodel.rulesheet.Condition aCondition)` Remove a Condition from the specified rule.
    `boolean` | `removeFilter(com.corticon.rulesemf.canonicalrulemodel.rulesheet.Filter aFilter)` Remove a Filter from the PRuleset.
    `boolean` | `removeLogicalVariable(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable)` Remove a LogicalVariable from the Rulesheet.
    `boolean` | `removeReferencedAttribute(com.corticon.rulesemf.canonicalrulemodel.rulesheet.ReferencedAttribute aReferencedAttribute)` Remove a ReferencedAttribute.
    `boolean` | `removeRule(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule)` Remove a rule from the rule set.
    `boolean` | `removeRuleStatement(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement)` Remove a RuleStatement from the rule set.
    `boolean` | `renameRulesheet(org.eclipse.emf.common.util.URI aURIRulesheetNew)` Rename the specified Rulesheet.
    `boolean` | `setActionExpression(com.corticon.rulesemf.canonicalrulemodel.rulesheet.Action aAction, java.lang.String astrExpression)` Sets the expression within the specified Action instance.
    `boolean` | `setConditionExpression(com.corticon.rulesemf.canonicalrulemodel.rulesheet.Condition aCondition, java.lang.String astrExpression)` Sets the expression within the specified Condition instance.
    `boolean` | `setFilterExpression(com.corticon.rulesemf.canonicalrulemodel.rulesheet.Filter aFilter, java.lang.String astrExpression)` Sets the logical expression within the specified Filter instance.
    `boolean` | `setLocalizationLogicalVariableName(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable, java.lang.String astrAlias, int aiLocalizationIndex)` Set the localized logical variable name (alias).
    `boolean` | `setLocalizationRuleStatementText(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement, java.lang.String astrText, int aiLocalizationIndex)` Set the localized rule statement text in a RuleStatement instance.
    `boolean` | `setLogicalLoopEnabled(boolean abLogicalLoopEnabled)` Deprecated. Use PRuleset EngineOperationMode PROCESS_ALL_LOGICAL_LOOPS.
    `boolean` | `setLogicalVariableExtendToDatabase(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable, boolean abExtendToDatabase)` Set the Logical Variable extend to database flag.
    `boolean` | `setLogicalVariableName(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable, java.lang.String astrLogicalVariableName)` Set the Logical Variable name.
    `boolean` | `setLogicalVariableQualifier(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable, IEntity aIEntity)` Set the Logical Variable qualifier.
    `void` | `setProcessAllLogicalLoops(boolean isAllLogicalLoops)` Set the OperationMode EngineOperationMode.PROCESS_ALL_LOGICAL_LOOPS_LITERAL for PRuleset if the given flag isAllLogicalLoops is true, otherwise set the OperationMode EngineOperationMode.IGNORE_LOGICAL_LOOPS_LITERAL
    `void` | `setProcessMultiRuleLogicalLoops(boolean isMultiRuleLogicalLoops)` Set the OperationMode EngineOperationMode.PROCESS_MULTI_RULE_LOGICAL_LOOPS_LITERAL for PRuleset if the given flag isMultiRuleLogicalLoops is true, otherwise set the OperationMode EngineOperationMode.IGNORE_LOGICAL_LOOPS_LITERAL
    `boolean` | `setRuleOverrides(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule, java.util.List aListOverriddenRules)` Set the overrides specifications for a given rule.
    `boolean` | `setRuleStatementAlias(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement, java.lang.String astrAlias)` Set the rule statement Alias in a RuleStatement instance.
    `boolean` | `setRuleStatementCategory(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement, java.lang.String astrCategory)` Set the rule statement Category in a RuleStatement instance.
    `boolean` | `setRuleStatementComments(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement, java.lang.String astrComments)` Set the rule statement Comments in a RuleStatement instance.
    `boolean` | `setRuleStatementID(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement, java.lang.String astrRuleStatementID)` Sets the rule statement ID in a RuleStatement instance.
    `boolean` | `setRuleStatementPostSeverity(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement, com.corticon.rulesemf.canonicalrulemodel.rulesheet.MessageSeverity aMessageSeverity)` Set the rule statement Post Severity in a RuleStatement instance.
    `boolean` | `setRuleStatementRuleLink(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement, java.lang.String astrRuleLink)` Set the rule statement Rule Link in a RuleStatement instance.
    `boolean` | `setRuleStatementRuleModelElements(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement, java.util.List aListModelElements)` Set the list of rule model elements associated with this RuleStatement instance.
    `boolean` | `setRuleStatementRuleName(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement, java.lang.String astrRuleName)` Set the rule statement Rule Name in a RuleStatement instance.
    `boolean` | `setRuleStatementSourceLink(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement, java.lang.String astrSourceLink)` Set the rule statement Source Link in a RuleStatement instance.
    `boolean` | `setRuleStatementSourceName(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement, java.lang.String astrSourceName)` Set the rule statement Source Name in a RuleStatement instance.
    `boolean` | `setRuleStatementText(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement, java.lang.String astrText)` Set the rule statement Text in a RuleStatement instance.
    `boolean` | `setVocabulary(IDomain aDomain)` Set the Rulesheet Vocabulary, technically a reference to the ecore root EPackage.

    - ### Methods inherited from interface com.corticon.eclipse.core.IModelAPI

      `activate, addAnnotation, addBatchedModelListener, addLowLevelModelListener, addModelListener, addResourceListener, addView, beginTransaction, cancelTransaction, canSetSupportedLocales, closeResource, createResource, deleteAnnotation, deleteAnnotation, deleteAnnotation, deleteResource, displayMessageBox, dispose, doPostLoadValidation, doSmartValidation, endTransaction, endTransaction, flushCommandStack, formatValidationMessageLocation, formatValidationMessageText, getAllLocalesProvidingCompleteLocalization, getAnnotation, getAnnotations, getAnnotations, getAnnotations, getAPIContextObject, getAsset, getBaseAttribute, getBaseAttributeString, getBatchedModelListeners, getBuildNumber, getBuildNumberOfLastValidationRulesChange, getEditingDomain, getErrors, getErrors, getIndexByLocale, getLocale, getLocalizedAttribute, getLocalizedAttributeString, getLowLevelModelListeners, getMajorServiceNumber, getMajorVersionNumber, getMessage, getMessage, getMessageBase, getMessageBoxDelegate, getMinorServiceNumber, getMinorVersionNumber, getModelAPIState, getModelListeners, getNewResourceName, getPersistenceServicesDelegate, getPreferences, getPrimaryResource, getPrimaryResourceURI, getScrollableMessageDelegate, getSupportedLocales, getSuppressBrokenLinkValidation, getSuppressValidation, getToolTip, getUpdateStamp, getUserInterfaceInfoDelegate, getValidationMessageCount, getValidationMessageCount, getValidationMessageCount, getValidationMessageCount, getValidationMessages, getValidationMessages, getWarnings, getWarnings, handleException, hasErrors, hasErrors, hasErrors, hasErrors, hasErrors, hasErrors, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasWarnings, hasWarnings, hasWarnings, hasWarnings, hasWarnings, hasWarnings, isAPIStateEstablished, isEnabledRedo, isEnabledUndo, isInhibitNotification, isLoaded, isOperationModeNormal, isOperationModeRedo, isOperationModeUndo, isPassive, isPostLoadInProgress, isPrimaryResourceSet, isReadOnly, isResourceActivated, isResourceConflict, isResourceDemandLoaded, isResourceLoaded, isScrollableMessageDelegateAvailable, isShowCanonicalValidationMessages, isSuppressModifiedFlagUpdates, isSuppressPostLoad, isTransactionInProgress, isValid, isValid, loadResource, loadResource, loadResource, newInstance, noOperation, postLoad, postMethod, postMethod, postsave, preMethod, presave, redo, reloadResource, remapResource, remapResource, removeBatchedModelListener, removeLowLevelModelListener, removeModelListener, removeResource, removeResourceListener, removeView, renameResource, rollbackTransaction, saveAll, saveResource, setAnnotation, setAPIContextObject, setAPIState, setBuildNumber, setEditingDomain, setInhibitNotification, setLocale, setMajorServiceNumber, setMajorVersionNumber, setMessageBoxDelegate, setMinorServiceNumber, setMinorVersionNumber, setModelAPIState, setModelListeners, setPassive, setPersistenceServicesDelegate, setPostLoadInProgress, setPreferencesDelegate, setPrimaryResource, setReadOnly, setScrollableMessageDelegate, setSupportedLocales, setSuppressBrokenLinkValidation, setSuppressModifiedFlagUpdates, setSuppressPostLoad, setSuppressValidation, setUserInterfaceInfoDelegate, undo, unloadResource, validate, validateLicense`

    - ### Methods inherited from interface com.corticon.rulebuilder.IScopeUtilities

      `getAttributeDataType, getAttributeDataTypeSubType, getFullyQualifiedEntityName, getMethodDataType, getMethodParamTypes, getRoleDataType, getRoleMultiplicity, isAttributeMandatory, isEntityByName, isExternalEntityByName, isRoleOfEntity, isSubTypeOf, isValidEntityAttribute, isValidEntityMethod`

- - ### Method Detail

    - #### addAction

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.Action addAction(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule,
                                                                            int aiIndex)

      Add a new Action instance to the specified PRule.
      Parameters:
        `aPRule` - PRule to which new Action should be added.
        `aiIndex` - Index of new instance.
      Returns:
        Action instance created.

    - #### addCondition

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.Condition addCondition(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule,
                                                                                  int aiIndex)

      Add a new Condition instance to the specified PRule.
      Parameters:
        `aPRule` - PRule to which new Condition should be added.
        `aiIndex` - Index of new instance.
      Returns:
        Condition instance created.

    - #### addFilter

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.Filter addFilter(int aiIndex)

      Add a new Filter instance to the PRuleset.
      Parameters:
        `aiIndex` - Index of new instance.
      Returns:
        Filter instance created.

    - #### addLogicalVariable

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable addLogicalVariable(org.eclipse.emf.ecore.EClass aEClass,
                                                                                              int aiIndex)

      Deprecated. Clean up of ModelAPI of EMF parametere objects. Replacing them with Corticon interfaces to conceal EMF behind top layer of our API. This will enable us to change out EMF if ever needed.
      Add a new LogicalVariable instance to the PRuleset. The new instance will be a "root" (entity-level) variable.
      Parameters:
        `aEClass` - EClass type that the new variable will represent.
        `aiIndex` - Index of new instance.
      Returns:
        LogicalVariable instance created.

    - #### addLogicalVariable

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable addLogicalVariable(IEntity aIEntity,
                                                                                              int aiIndex)

      Add a new LogicalVariable instance to the PRuleset. The new instance will be a "root" (entity-level) variable.
      Parameters:
        `aIEntity` - IEntity type that the new variable will represent.
        `aiIndex` - Index of new instance.
      Returns:
        LogicalVariable instance created.

    - #### addLogicalVariable

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable addLogicalVariable(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable,
                                                                                              org.eclipse.emf.ecore.EReference aEReference,
                                                                                              int aiIndex)

      Deprecated. Clean up of ModelAPI of EMF parametere objects. Replacing them with Corticon interfaces to conceal EMF behind top layer of our API. This will enable us to change out EMF if ever needed.
      Add a new LogicalVariable instance to the PRuleset. The new instance will be extended from an existing LogicalVariable.
      Parameters:
        `aLogicalVariable` - LogicalVariable from which the new LogicalVariable will be extended.
        `aEReference` - EReference to representing traversed association role.
        `aiIndex` - Index of new instance.
      Returns:
        LogicalVariable instance created.

    - #### addLogicalVariable

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable addLogicalVariable(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable,
                                                                                              IAssociationEnd aIAssociationEnd,
                                                                                              int aiIndex)

      Add a new LogicalVariable instance to the PRuleset. The new instance will be extended from an existing LogicalVariable.
      Parameters:
        `aIAssociationEnd` - AssociationEnd from which the new LogicalVariable will be extended.
        `aEReference` - EReference to representing traversed association role.
        `aiIndex` - Index of new instance.
      Returns:
        LogicalVariable instance created.

    - #### addReferencedAttribute

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.ReferencedAttribute addReferencedAttribute(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable,
                                                                                                      IAttribute aIAttribute,
                                                                                                      int aiIndex)

      Add a new ReferencedAttribute instance to the specified LogicalVariable.
      Parameters:
        `aLogicalVariable` - LogicalVariable to which the new ReferencedAtribute will be added.
        `aIAttribute` - Attribute facade representing new attribute to be added.
        `aiIndex` - Index of new instance.
      Returns:
        ReferencedAttribute created.

    - #### addRule

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule addRule(int aiIndex)

      Add a new PRule to the rule set.
      Parameters:
        `aiIndex` - Index of new instance.
      Returns:
        PRule instance created.

    - #### addRuleStatement

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement addRuleStatement(int aiIndex)

      Add a new RuleStatement instance to the PRuleset.
      Parameters:
        `aiIndex` - Index of new instance.
      Returns:
        RuleStatement instance created.

    - #### createAction

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.Action createAction()

      Create and return a new independent Action instance.
      Returns:
        Action instance.

    - #### createCondition

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.Condition createCondition()

      Create and return a new independent Condition instance.
      Returns:
        Condition instance.

    - #### createFilter

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.Filter createFilter()

      Create and return a new independent Filter instance.
      Returns:
        Filter instance.

    - #### createRule

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule createRule()

      Create and return a new independent PRule instance.

    - #### createRulesheet

          com.corticon.rulesemf.assetmodel.RulesheetAsset createRulesheet(org.eclipse.emf.common.util.URI aURIRulesheet)

      Create a new Rulesheet resource with the specified URI. Examples:
      platform:/LoanProject/Loan.ers platform:/LoanProject/ED_Borrower.ers
      This function creates a new Rulesheet Resource in the editing domain, with a new RulesheetAsset instance as the root object.
      Parameters:
        `aURIRulesheet` - New Rulesheet URI.
      Returns:
        New RulesheetAsset instance.

    - #### createRuleStatement

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement createRuleStatement()

      Create and return a new independent RuleStatement instance.
      Returns:
        RuleStatement instance.

    - #### deleteRulesheet

          void deleteRulesheet()

      Delete the Rulesheet and remove its respective Resource.

    - #### findEntity

          IEntity findEntity(java.lang.String astrEntityName)

      Given an entity name appearing in the Scope section, return the corresponding IEntity by traversing from Scope to the Vocabulary.
      Parameters:
        `astrEntityName` - Unqualified entity name appearing in Scope.
      Returns:
        IEntity from Vocabulary.

    - #### findLogicalVariableImplicit

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable findLogicalVariableImplicit(java.lang.String astrInput)

      Find the logical variable corresponding to a specified alias, implicit variable or combination. Examples: Customer Customer.order cust cust.order
      Parameters:
        `astrInput` - Alias, implicit variable or combination.
      Returns:
        LogicalVariable matching specified input or `null`.

    - #### findLogicalVariable

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable findLogicalVariable(java.lang.String astrAlias)

      Find the logical variable corresponding to a specified alias.
      Parameters:
        `astrAlias` - Input alias.
      Returns:
        LogicalVariable matching alias.

    - #### findRuleset

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRuleset findRuleset()

      Finder for PRuleset. This finds the PRuleset through the RulesheetAsset.
      Returns:
        Instance of PRuleset.

    - #### findRulesheetAsset

          com.corticon.rulesemf.assetmodel.RulesheetAsset findRulesheetAsset()

      Finder for RulesheetAsset. This is just a convenience method to return the API context instance.
      Returns:
        Instance of RulesheetAsset.

    - #### insertAction

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.Action insertAction(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule,
                                                                               int aiIndex)

      Insert a new Action instance into the specified PRule.
      Parameters:
        `aPRule` - PRule to which new Action should be added.
        `aiIndex` - Index of new instance.
      Returns:
        Action instance created.

    - #### insertCondition

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.Condition insertCondition(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule,
                                                                                     int aiIndex)

      Insert a new Condition instance into the specified PRule.
      Parameters:
        `aPRule` - PRule to which new Condition should be added.
        `aiIndex` - Index of new instance.
      Returns:
        Condition instance created.

    - #### insertRule

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule insertRule(int aiIndex)

      Insert a new PRule instance into the PRuleset.
      Parameters:
        `aiIndex` - Index of new instance.
      Returns:
        PRule instance created.

    - #### makeOpaqueExpression

          com.corticon.rulesemf.expression.OpaqueExpression makeOpaqueExpression(java.lang.String astrValue)

      Factory method to create an OpaqueExpression from a string.
      Parameters:
        `astrValue` - Value string.
      Returns:
        New OpaqueExpression instance or `null`.

    - #### makeRulesheetString

          com.corticon.rulesemf.canonicalrulemodel.rulesheet.RulesheetString makeRulesheetString(java.lang.String astrValue)

      Factory method to create a RulesheetString from a string.
      Parameters:
        `astrValue` - Value string.
      Returns:
        New RulesheetString instance or `null`.

    - #### getAliasUtilities

          com.corticon.rulebuilder.IAliasUtilities getAliasUtilities()

      Return an instance of alias utilities service.
      Returns:
        Instance of IAliasUtilities.

    - #### getOperationsModelAPI

          IOperationsModelAPI getOperationsModelAPI()

      Return an instance of the Operations model API with its state set identically to *this* API.
      Returns:
        Instance of IOperationsModelAPI.

    - #### getParser

          com.corticon.rulebuilder.IParser getParser()

      Return an instance of the parsing service.
      Returns:
        Instance of IParser.

    - #### getRulebuilderFactory

          com.corticon.rulebuilder.IRulebuilderFactory getRulebuilderFactory()

      Return an instance of IRulebuilder factory.
      Returns:
        IRulebuilderFactory instance.

    - #### getSemanticAnalysis

          com.corticon.rulebuilder.ISemanticAnalysis getSemanticAnalysis()

      Return an instance of the semantic analysis service.
      Returns:
        Instance of SemanticAnalysisImpl.

    - #### getNewRulesheetName

          java.lang.String getNewRulesheetName(org.eclipse.emf.common.util.URI aURIContainer)

      Given the URI of a container in the storage system, create a new unique Rulesheet name using sequence numbers if necessary. Example (URI shown is for Eclipse platform):
      platform:/Examples/TradeAllocation/Rules
      Parameters:
        `aURIContainer` - URI of container.
      Returns:
        New Rulesheet name.

    - #### getVocabularyModelAPI

          IVocabularyModelAPI getVocabularyModelAPI()

      Return an instance of the Vocabulary model API with its state set identically to *this* API. This Vocabulary API instance can be used for parsing utilities or any other purpose.
      Returns:
        Instance of IVocabularyModelAPI.

    - #### getVocabularyURI

          org.eclipse.emf.common.util.URI getVocabularyURI()

      Return the URI of the Vocabulary, even if that Vocabulary is missing.
      Returns:
        URI of Vocabulary.

    - #### isVocabularyAvailable

          boolean isVocabularyAvailable()

      Determine whether the Vocabulary for this Rulesheet is available.
      Returns:
        `true` if Vocabulary is available.

    - #### removeAction

          boolean removeAction(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule,
                             com.corticon.rulesemf.canonicalrulemodel.rulesheet.Action aAction)

      Remove an Action from the specified PRule.
      Parameters:
        `aPRule` - PRule from which Action will be removed.
        `aAction` - Action to be removed.
      Returns:
        `true` if the command was successful.

    - #### removeCondition

          boolean removeCondition(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule,
                                com.corticon.rulesemf.canonicalrulemodel.rulesheet.Condition aCondition)

      Remove a Condition from the specified rule.
      Parameters:
        `aPRule` - PRule from which condition will be removed.
        `aCondition` - Condition to be removed.
      Returns:
        `true` if the command was successful.

    - #### removeFilter

          boolean removeFilter(com.corticon.rulesemf.canonicalrulemodel.rulesheet.Filter aFilter)

      Remove a Filter from the PRuleset.
      Parameters:
        `aFilter` - Filter to be removed.
      Returns:
        `true` if the command was successful.

    - #### removeLogicalVariable

          boolean removeLogicalVariable(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable)

      Remove a LogicalVariable from the Rulesheet.
      Parameters:
        `aLogicalVariable` - LogicalVariable to be removed.
      Returns:
        `true` if the command was successful.

    - #### removeReferencedAttribute

          boolean removeReferencedAttribute(com.corticon.rulesemf.canonicalrulemodel.rulesheet.ReferencedAttribute aReferencedAttribute)

      Remove a ReferencedAttribute.
      Parameters:
        `aReferencedAttribute` - ReferencedAttribute to be removed.
      Returns:
        `true` if the command was successful.

    - #### removeRule

          boolean removeRule(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule)

      Remove a rule from the rule set.
      Parameters:
        `aPRule` - PRule to be removed.
      Returns:
        `true` if the command was successful.

    - #### removeRuleStatement

          boolean removeRuleStatement(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement)

      Remove a RuleStatement from the rule set.
      Parameters:
        `aRuleStatement` - RuleStatement to be removed.
      Returns:
        `true` if the command was successful.

    - #### renameRulesheet

          boolean renameRulesheet(org.eclipse.emf.common.util.URI aURIRulesheetNew)

      Rename the specified Rulesheet.
      Parameters:
        `aURIRulesheetNew` - New Rulesheet URI.
      Returns:
        `true` if the command was successful.

    - #### setActionExpression

          boolean setActionExpression(com.corticon.rulesemf.canonicalrulemodel.rulesheet.Action aAction,
                                    java.lang.String astrExpression)

      Sets the expression within the specified Action instance.
      Parameters:
        `aAction` - Action to update.
        `astrExpression` - Action expression.
      Returns:
        `true` if the set command was successful.

    - #### setConditionExpression

          boolean setConditionExpression(com.corticon.rulesemf.canonicalrulemodel.rulesheet.Condition aCondition,
                                       java.lang.String astrExpression)

      Sets the expression within the specified Condition instance.
      Parameters:
        `aCondition` - Condition to update.
        `astrExpression` - Condition expression.
      Returns:
        `true` if the set command was successful.

    - #### setFilterExpression

          boolean setFilterExpression(com.corticon.rulesemf.canonicalrulemodel.rulesheet.Filter aFilter,
                                    java.lang.String astrExpression)

      Sets the logical expression within the specified Filter instance.
      Parameters:
        `aFilter` - Filter instance to update.
        `astrExpression` - Filter expression.
      Returns:
        `true` if the set command was successful.

    - #### setLocalizationLogicalVariableName

          boolean setLocalizationLogicalVariableName(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable,
                                                   java.lang.String astrAlias,
                                                   int aiLocalizationIndex)

      Set the localized logical variable name (alias).
      Parameters:
        `aLogicalVariable` - LogicalVariable whose alias is to be set.
        `astrAlias` - Alias name.
        `aiLocalizationIndex` - Localization index.
      Returns:
        `true` if the set command was successful.

    - #### setLocalizationRuleStatementText

          boolean setLocalizationRuleStatementText(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement,
                                                 java.lang.String astrText,
                                                 int aiLocalizationIndex)

      Set the localized rule statement text in a RuleStatement instance.
      Parameters:
        `aRuleStatement` - RuleStatement instance to be updated.
        `astrText` - Rule statement text.
        `aiLocalizationIndex` - Localization index.
      Returns:
        `true` if the set command was successful.

    - #### setLogicalLoopEnabled

          boolean setLogicalLoopEnabled(boolean abLogicalLoopEnabled)

      Deprecated. Use PRuleset EngineOperationMode PROCESS_ALL_LOGICAL_LOOPS.
      Set the Rulesheet logical loop indicator.
      Parameters:
        `aRulesheet` - Instance of Rulesheet to be affected.
        `abLogicalLoopEnabled` - Logical loop enabled indicator.
      Returns:
        `true` if the set command was successful.

    - #### setLogicalVariableExtendToDatabase

          boolean setLogicalVariableExtendToDatabase(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable,
                                                   boolean abExtendToDatabase)

      Set the Logical Variable extend to database flag.
      Parameters:
        `aLogicalVariable` - LogicalVariable instance.
        `abExtendToDatabase` - Extend to database flag `true` or `false`.
      Returns:
        `true` if the set command was successful.

    - #### setLogicalVariableName

          boolean setLogicalVariableName(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable,
                                       java.lang.String astrLogicalVariableName)

      Set the Logical Variable name.
      Parameters:
        `aLogicalVariable` - LogicalVariable whose name is to be set.
        `astrLogicalVariableName` - Logical variable name.
      Returns:
        `true` if the set command was successful.

    - #### setLogicalVariableQualifier

          boolean setLogicalVariableQualifier(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable,
                                            IEntity aIEntity)

      Set the Logical Variable qualifier.
      Parameters:
        `aLogicalVariable` - LogicalVariable whose qualifier is to be set.
        `aIEntity` - Entity qualifier for this logical variable.
      Returns:
        `true` if the set command was successful.

    - #### setRuleOverrides

          boolean setRuleOverrides(com.corticon.rulesemf.canonicalrulemodel.rulesheet.PRule aPRule,
                                 java.util.List aListOverriddenRules)

      Set the overrides specifications for a given rule.
      Parameters:
        `aPRuleOverriding` - Overriding rule.
        `aListOverriddenRules` - List of overridden rules.

    - #### setRuleStatementID

          boolean setRuleStatementID(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement,
                                   java.lang.String astrRuleStatementID)

      Sets the rule statement ID in a RuleStatement instance.
      Parameters:
        `aRuleStatement` - RuleStatement instance to be updated.
        `astrID` - Rule statement ID.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementPostSeverity

          boolean setRuleStatementPostSeverity(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement,
                                             com.corticon.rulesemf.canonicalrulemodel.rulesheet.MessageSeverity aMessageSeverity)

      Set the rule statement Post Severity in a RuleStatement instance.
      Parameters:
        `aRuleStatement` - RuleStatement instance to be updated.
        `aMessageSeverity` - MessageSeverity enumerated value.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementAlias

          boolean setRuleStatementAlias(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement,
                                      java.lang.String astrAlias)

      Set the rule statement Alias in a RuleStatement instance.
      Parameters:
        `aRuleStatement` - RuleStatement instance to be updated.
        `astrAlias` - Alias (e.g., Order.item).
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementText

          boolean setRuleStatementText(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement,
                                     java.lang.String astrText)

      Set the rule statement Text in a RuleStatement instance.
      Parameters:
        `aRuleStatement` - RuleStatement instance to be updated.
        `astrText` - Rule statement text.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementRuleName

          boolean setRuleStatementRuleName(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement,
                                         java.lang.String astrRuleName)

      Set the rule statement Rule Name in a RuleStatement instance.
      Parameters:
        `aRuleStatement` - RuleStatement instance to be updated.
        `astrRuleName` - Rule statement Rule Name.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementRuleLink

          boolean setRuleStatementRuleLink(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement,
                                         java.lang.String astrRuleLink)

      Set the rule statement Rule Link in a RuleStatement instance.
      Parameters:
        `aRuleStatement` - RuleStatement instance to be updated.
        `astrRuleLink` - Rule statement Rule Link.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementSourceName

          boolean setRuleStatementSourceName(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement,
                                           java.lang.String astrSourceName)

      Set the rule statement Source Name in a RuleStatement instance.
      Parameters:
        `aRuleStatement` - RuleStatement instance to be updated.
        `astrSourceName` - Rule statement Source Name.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementSourceLink

          boolean setRuleStatementSourceLink(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement,
                                           java.lang.String astrSourceLink)

      Set the rule statement Source Link in a RuleStatement instance.
      Parameters:
        `aRuleStatement` - RuleStatement instance to be updated.
        `astrSourceLink` - Rule statement Source Link.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementCategory

          boolean setRuleStatementCategory(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement,
                                         java.lang.String astrCategory)

      Set the rule statement Category in a RuleStatement instance.
      Parameters:
        `aRuleStatement` - RuleStatement instance to be updated.
        `astrCategory` - Rule statement Category.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementComments

          boolean setRuleStatementComments(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement,
                                         java.lang.String astrComments)

      Set the rule statement Comments in a RuleStatement instance.
      Parameters:
        `aRuleStatement` - RuleStatement instance to be updated.
        `astrComments` - Rule statement Comments.
      Returns:
        `true` if the set command was successful.

    - #### setRuleStatementRuleModelElements

          boolean setRuleStatementRuleModelElements(com.corticon.rulesemf.canonicalrulemodel.rulesheet.RuleStatement aRuleStatement,
                                                  java.util.List aListModelElements)

      Set the list of rule model elements associated with this RuleStatement instance.
      Parameters:
        `aListModelElements` - List of model elements (typically PRule, Condition and Action instances).
      Returns:
        `true` if the set command was successful.

    - #### setVocabulary

          boolean setVocabulary(IDomain aDomain)

      Set the Rulesheet Vocabulary, technically a reference to the ecore root EPackage.
      Parameters:
        `aDomain` -
      Returns:

    - #### getAllLogicalVariables

          java.util.List getAllLogicalVariables(java.util.List aListLogicalVariables,
                                              java.util.List aList)

      Return a list of all Logical Variables.
      Parameters:
        `aListLogicalVariables` - Logical variables to process.
        `aList` - List to be accumulated (updated in place recursively).
      Returns:
        List of all LogicalVariables instances.

    - #### getLogicalVariablePath

          java.lang.String getLogicalVariablePath(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable,
                                                boolean abBase)

      Given a LogicalVariable instance, traverse upwards formatting in order to construct a base or localized string representation of the alias starting with the root entity or alias name.
      Example:
      Customer +-order [co] +-item
      Input ScopeNode Customer would return "Customer". Input ScopeNode order would return "co". Input ScopeNode item would return "co.item".
      Specified by:
        `getLogicalVariablePath` in interface `com.corticon.rulebuilder.IScopeUtilities`
      Parameters:
        `aLogicalVariable` - LogicalVariable for which alias name should be returned.
        `abBase` - `true` to return string in base form.
      Returns:
        Alias in string form.

    - #### getVocabulary

          IDomain getVocabulary()

      Get vocabulary
      Returns:

    - #### isProcessAllLogicalLoops

          boolean isProcessAllLogicalLoops()

      Returns true, if the OperationMode is set to EngineOperationMode.PROCESS_ALL_LOGICAL_LOOPS
      Returns:
        true, if OperationMode is set to EngineOperationMode.PROCESS_ALL_LOGICAL_LOOPS

    - #### setProcessAllLogicalLoops

          void setProcessAllLogicalLoops(boolean isAllLogicalLoops)

      Set the OperationMode EngineOperationMode.PROCESS_ALL_LOGICAL_LOOPS_LITERAL for PRuleset if the given flag isAllLogicalLoops is true, otherwise set the OperationMode EngineOperationMode.IGNORE_LOGICAL_LOOPS_LITERAL
      Parameters:
        `isAllLogicalLoops` -

    - #### isProcessMultiRuleLogicalLoops

          boolean isProcessMultiRuleLogicalLoops()

      Returns true, if the OperationMode is set to EngineOperationMode.PROCESS_MULTI_RULE_LOGICAL_LOOPS
      Returns:
        true, if OperationMode is set to EngineOperationMode.PROCESS_MULTI_RULE_LOGICAL_LOOPS

    - #### setProcessMultiRuleLogicalLoops

          void setProcessMultiRuleLogicalLoops(boolean isMultiRuleLogicalLoops)

      Set the OperationMode EngineOperationMode.PROCESS_MULTI_RULE_LOGICAL_LOOPS_LITERAL for PRuleset if the given flag isMultiRuleLogicalLoops is true, otherwise set the OperationMode EngineOperationMode.IGNORE_LOGICAL_LOOPS_LITERAL
      Parameters:
        `isMultiRuleLogicalLoops` -

    - #### getConvertedAliasName

          java.lang.String getConvertedAliasName(java.lang.String astrAliasName)

      This method will take in the astrAliasName and verify that it conforms to Corticon's naming standards. If it does, that same name will be returned. If it doesn't, this method will return a new recommended name that the client should use.
      Parameters:
        `astrAliasName` -
      Returns:

    - #### getNextAvailableAliasName

          java.lang.String getNextAvailableAliasName(java.lang.String astrAliasName)

      This method will take in the astrAliasName that is passed in and verify that it is unique in the Rulesheet. If it does, that same name will be returned. If it doesn't, this method will return a new recommended name that the client should use.
      Parameters:
        `astrAliasName` -
      Returns:

    - #### getNextAvailableConvertedAliasName

          java.lang.String getNextAvailableConvertedAliasName(java.lang.String astrAliasName)

      This method will take in the astrAliasName and call into getConvertedAliasName(String) and getNextAvailableAliasName(String) to return a recommended alias name.
      Parameters:
        `astrAliasName` -
      Returns:

    - #### getTotalNumberOfRules

          int getTotalNumberOfRules()

      Returns the total number of Rules for the Rulesheet
      Returns:
        int total number of rules

    - #### isDatabaseEnabled

          boolean isDatabaseEnabled(com.corticon.rulesemf.canonicalrulemodel.rulesheet.LogicalVariable aLogicalVariable)

      Method to determine whether a given LogicalVariable should be considered database enabled. For top-level entities, this is a matter of the isDatabase toggle (Extend to Database). For lower-level entities it is a matter of the Datastore Persistent flags in the Vocabulary.
      Parameters:
        `aLogicalVariable` - LogicalVariable to test.
      Returns:
        `true` if LogicalVariable is effectively database enabled.

    - #### isDatabaseAccessEnabled

          boolean isDatabaseAccessEnabled()

      Method to return an indication of whether database access support is enabled.
      Returns:
        `true` if database access is enabled.

    - #### isDeployable

          boolean isDeployable()

      Return an indication of whether this asset is deployable (i.e., whether the asset has any un-demoted errors).
      Returns:
        `true` if the asset is deployable.

    - #### isFilterDatabaseReady

          boolean isFilterDatabaseReady(com.corticon.rulesemf.canonicalrulemodel.rulesheet.Filter aFilter)

      Determine if the input filter is a possible database query
      Parameters:
        `aFilter` -
      Returns:

Copyright © 2005-2013 Progress Software Corporation and/or its subsidiaries and affiliates. All rights reserved.